#include<Ethernet.h>
#include<SPI.h>
#include<SD.h>
#include<EEPROM.h>
#include<Wire.h>
#define control 90
#define dates_pageWeb 50
#define dates_hora 90
#define dates_min 15
#define rtc_add 0x68

byte mac[] = {0xDE, 0xAD, 0xBE, 0xEF, 0xFE, 0xED};
//para mi lap la ip es: 192.168.1
IPAddress ip(192, 168, 137, 100);
EthernetServer server(80);
File paginaweb;
char HTTP_req[control] = {0};
char req_index = 0;
//char dates[dates_pageWeb]={0};
char d5[dates_hora] = {0};
char d4[dates_hora] = {0};
//char minute_pageWerb[dates_min]={0};
boolean LED_state[1] = {0};
unsigned int t_agregado = 1;
int seconds;
int minutes;
int hours;
int day;
int month;
int year;
String text_pass;
int long_pass;
//variables de uso exclusivo de memoria EEPROM
int len_eeprom;
char array_eeprom[8] = {0};
String text_eeprom, toString_eeprom;
//--------------------------------------------
String text_pass2;
int long_pass2;
int len_eeprom2;
char array_eeprom2[6] = {0};
String text_eeprom2, toString_eeprom2;

void setup()
{
  pinMode(10, OUTPUT);
  digitalWrite(10, HIGH);
  pinMode(6, OUTPUT);
  Serial.begin(9600);
  Wire.begin();
  Serial.println("iniciando la uSD");
  if (!SD.begin(4))
  {
    Serial.println("Error memoria uSD no se pudo inicializar");
    Serial.println("favor de verificar si existe alguna en la lectora");
    return;
  }
  Serial.println("empezando la busqueda del archivo:");
  Serial.println("pagina.htm");
  if (!SD.exists("pagina.htm"))
  {
    Serial.println("archivo no encontrado");
  }
  Serial.println("archivo encontado y cargado");
  Ethernet.begin(mac, ip);
  server.begin();
  pinMode(3, INPUT);
  pinMode(5, OUTPUT);
  len_eeprom  = EEPROM.read(0);
  len_eeprom2 = EEPROM.read(16);
  //dirección de flag 1 para habilitar pagina usuario
  EEPROM.write(9, 0);
  //dirección de flag 2 para habilitar pagina administrador
  EEPROM.write(17, 0);
}

void loop()
{
  bool flag_access = false;
  EthernetClient client = server.available();
  if (client)
  {
    boolean salta = true;
    while (client.connected())
    {
      if (client.available())
      {
        char c = client.read();
        if (req_index < (control - 1))
        {
          HTTP_req[req_index] = c;
          req_index++;
        }
        //Serial.println(c);
        if (c == '\n' && salta)
        {
          client.println("HTTP/1.1 200 OK");
          //intercambio de información mediante el uso de una petición GET acompañada del nombre ajax_peticion
          if (contenedor(HTTP_req, "ajax_peticion"))
          {
            client.println("HTTP/1.1 200 OK");
            client.println("Connection: keep-alive");
            client.println();
            tiempo1(client);
            ajuste_pagina();
            if (contenedor(HTTP_req, "&h="))
            {
              String llave = "h";
              String llave1 = "m";
              String converh, converm;
              char *o = strstr(HTTP_req, "&h=");
              char *m = strstr(HTTP_req, "&m=");
              Serial.println("hora:" + getText(llave, o));
              Serial.println("minutos:" + getText1(llave1, m));
              converh = getText(llave, o);
              hours = converh.toInt();
              converm = getText1(llave1, m);
              minutes = converm.toInt();
              set_time();
            }
            if (contenedor(HTTP_req, "&p="))
            {
              String close_page = "p";
              char *c = strstr(HTTP_req, "&p=");
              String close_text, f = "cerrar";
              close_text = getPass(close_page, c);
              Serial.println(close_text);
              if (f.equals(close_text))
              {
                Serial.println("igual");
                EEPROM.write(9, 0);
              }
            }
          }

          else if (contenedor(HTTP_req, "acceso_reloj"))
          {
            client.println("HTTP/1.1 200 OK");
            client.println("Connection: keep-alive");
            client.println();
            if (contenedor(HTTP_req, "&x="))
            {
              String pass_label = "x";
              char *pass = strstr(HTTP_req, "&x=");
              Serial.println("acceso:" + getPass(pass_label, pass));
              text_pass = getPass(pass_label, pass);
              long_pass = text_pass.length();
              Serial.println("*****");
              Serial.println(long_pass);
              Serial.println("*****");
              if (acceso_user(text_pass, long_pass))
              {
                xml_access(client);
              }
            }
          }

          else if (contenedor(HTTP_req, "admin_reloj"))
          {
            client.println("HTTP/1.1 200 OK");
            client.println("Connection: keep-alive");
            client.println();
            if (contenedor(HTTP_req, "&k="))
            {
              String pass_label2 = "k";
              char *pass2 = strstr(HTTP_req, "&k=");
              Serial.println("acceso:" + getPass(pass_label2, pass2));
              text_pass2 = getPass(pass_label2, pass2);
              long_pass2 = text_pass2.length();
              Serial.println("*****");
              Serial.println(long_pass2);
              Serial.println("*****");
              if (acceso_admin(text_pass2, long_pass2))
              {
                xml_admin(client);
              }
            }
          }
          
          else if(contenedor(HTTP_req, "reloj_admin"))
          {
            client.println("HTTP/1.1 200 OK");
            client.println("Connection: keep-alive");
            client.println();
            if (contenedor(HTTP_req, "&p="))
            {
              String close_page2 = "p";
              char *c2 = strstr(HTTP_req, "&p=");
              String close_text2, f2 = "cerrar";
              close_text2 = getPass(close_page2, c2);
              if (f2.equals(close_text2))
              {
                EEPROM.write(17, 0);
              }
            }
          }

          else
          {
            //pagina de administrador
            if (contenedor(HTTP_req, "GET / ") || contenedor(HTTP_req, "GET /pass.htm"))
            {
              client.println("HTTP/1.1 200 OK");
              client.println("Content-Type: text/html");
              client.println("Connnection: close");
              client.println();
              paginaweb = SD.open("pass.htm");
            }

            else if (contenedor(HTTP_req, "GET /esc.jpg"))
            {
              paginaweb = SD.open("esc.jpg");
              if (paginaweb)
              {
                client.println("HTTP/1.1 200 OK");
                client.println();
              }
            }

            //verificacion de metodo de obtencion GET para abrir el archivo que contiene el control de acceso

            if (EEPROM.read(9) == 1)
            {
              if (contenedor(HTTP_req, "GET /ese3.htm"))
              {
                client.println("HTTP/1.1 200 OK");
                client.println("Content-Type: text/html");
                client.println("Connnection: close");
                client.println();
                paginaweb = SD.open("ese3.htm");
              }

              else if (contenedor(HTTP_req, "GET /ese8.jpg"))
              {
                paginaweb = SD.open("ese8.jpg");
                if (paginaweb)
                {
                  client.println("HTTP/1.1 200 OK");
                  client.println();
                }
              }

              else if (contenedor(HTTP_req, "GET /ittg.jpg"))
              {
                paginaweb = SD.open("ittg.jpg");
                if (paginaweb)
                {
                  client.println("HTTP/1.1 200 OK");
                  client.println();
                }
              }

              else if (contenedor(HTTP_req, "GET /admin.htm"))
              {
                client.println("HTTP/1.1 200 OK");
                client.println("Content-Type: text/html");
                client.println("Connnection: close");
                client.println();
                paginaweb = SD.open("admin.htm");
              }

              //abrir pagina de monitoreo del los equipos
              if (EEPROM.read(17) == 1)
              {
                if (contenedor(HTTP_req, "GET /ese1.htm"))
                {
                  client.println("HTTP/1.1 200 OK");
                  client.println("Content-Type: text/html");
                  client.println("Connnection: close");
                  client.println();
                  paginaweb = SD.open("ese1.htm");
                }
              }
              
               else if (contenedor(HTTP_req, "GET /ese2.jpg"))
            {
              paginaweb = SD.open("ese2.jpg");
              if (paginaweb)
              {
                client.println("HTTP/1.1 200 OK");
                client.println();
              }
            }

              else if (contenedor(HTTP_req, "GET /manual.htm"))
              {
                client.println("HTTP/1.1 200 OK");
                client.println("Content-Type: text/html");
                client.println("Connnection: close");
                client.println();
                paginaweb = SD.open("manual.htm");
              }
            }

            if (paginaweb)
            {
              while (paginaweb.available())
              {
                client.write(paginaweb.read());
              }
              paginaweb.close();
            }
          }
          //Serial.println(HTTP_req);
          req_index = 0;
          borrarmemoria(HTTP_req, control);
          break;
        }
        if (c == '\n')
        {
          salta = true;
        }
        else if (c != '\r')
        {
          salta = false;
        }
      }
    }
    delay(1);
    client.stop();
  }
}

char contenedor(char *str, char *sfind)
{
  char found = 0;
  char index = 0;
  char len = 0;

  len = strlen(str);

  if (strlen(sfind) > len)
  {
    return 0;
  }
  while (index < len)
  {
    if (str[index] == sfind[found])
    {
      found++;
      if (strlen(sfind) == found)
      {
        return 1;
      }
    }
    else {
      found = 0;
    }
    index++;
  }
  return 0;
}

void borrarmemoria(char *str, char length)
{
  for (int i; i < length; i++)
  {
    str[i] = 0;
  }
}

//--------------------impresión de datos en la página---------------------------
void tiempo1(EthernetClient cl)
{
  cl.print("<?xml version = \"1.0\" ?>");
  cl.print("<inputs>");
  get_time();
  cl.print("<analog1>");
  cl.print(minutes);
  cl.print("</analog1>");

  cl.print("<analog2>");
  cl.print(hours);
  cl.print("</analog2>");

  cl.print("<analog3>");
  cl.print(seconds);
  cl.print("</analog3>");

  cl.println("</inputs>");
}

//---------------verificación de petición--------------------------------------------------------------
void ajuste_pagina()
{
  if (contenedor(HTTP_req, "hor=1"))
  {
    web_hour();
  }

  else if (contenedor(HTTP_req, "hor=0"))
  {
    ;
  }

  if (contenedor(HTTP_req, "min=1"))
  {
    web_minute();
  }

  else if (contenedor(HTTP_req, "min=0"))
  {
    ;
  }
}

//------------------------conversión de datos de bcd a decimal y de decimal a bcd------------------------------------
byte decAbcd(byte conversion)
{
  return ((conversion / 10 * 16) + (conversion % 10));
}

byte bcdAdec(byte conversion)
{
  return ((conversion / 16 * 10) + (conversion % 16));
}

//----------------------manipulación del RTC---------------------------------------------------------

void get_time()
{
  Wire.beginTransmission(rtc_add);
  Wire.write(0);
  Wire.endTransmission();
  Wire.requestFrom(rtc_add, 3);
  seconds = bcdAdec(Wire.read());
  minutes = bcdAdec(Wire.read());
  hours = bcdAdec(Wire.read() & 0x3f);
}

void set_time()
{
  Wire.beginTransmission(rtc_add);
  Wire.write(0x00); //(0)
  Wire.write(decAbcd(seconds));
  Wire.write(decAbcd(minutes));
  Wire.write(decAbcd(hours));
  Wire.endTransmission();
}

void web_hour()
{
  hours++;
  if (hours > 23)
  {
    hours = 0;
  }
  set_time();
}

void web_minute()
{
  minutes++;
  if (minutes > 59)
  {
    minutes = 0;
    hours++;
    if (hours > 23) hours = 0;
  }
  set_time();
}

//-----------------------------obtención de tiempos horas y minutos---------------------------------------------------
String getText(String index, String web)
{
  int lentext = web.length();
  int lenindex = index.length();
  int start = web.indexOf(index) + lenindex + 1;
  String valor = "";

  for (int i = start; i < lentext; i++)
  {
    String caracter = web.substring(i, i + 1);
    if (caracter != "&")
    {
      valor = valor + caracter;
    }
    else
    {
      i = lentext;
    }
  }
  return valor;
}

String getText1(String index1, String web1)
{
  int lentext1  = web1.length();
  int lenindex1 = index1.length();
  int start1 = web1. indexOf(index1) + lenindex1 + 1;
  String valor1 = "";

  for (int j = start1; j < lentext1; j++)
  {
    String caracter1 = web1.substring(j, j + 1);
    if (caracter1 != "&")
    {
      valor1 = valor1 + caracter1;
    }
    else
    {
      j = lentext1;
    }
  }
  return valor1;
}
//-----------------------------------------------------------------------------------------------
void sensado(EthernetClient c)
{
  int sensor;
  c.print("<?xml version = \"1.0\" ?>");
  c.print("<inputs>");
  get_time();
  sensor = analogRead(0);
  c.print("<analog>");
  c.print(sensor);
  c.print("</analog>");

  c.println("</inputs>");
}

//----------------------------- control de acceso --------------------------------------------------
String getPass(String index2, String web2)
{
  int lentext2 = web2.length();
  int lenindex2 = index2.length();
  int start2 = web2.indexOf(index2) + lenindex2 + 1;
  String valor2 = "";

  for (int i = start2; i < lentext2; i++)
  {
    String caracter2 = web2.substring(i, i + 1);
    if (caracter2 != "&")
    {
      valor2 = valor2 + caracter2;
    }
    else
    {
      i = lentext2;
    }
  }
  return valor2;
}

boolean acceso_user(String t, int long_t)
{
  bool flag = false;
  for (int x = 0; x <= len_eeprom; x++)
  {
    array_eeprom[x] = EEPROM.read(x + 1);
  }
  toString_eeprom = (String)array_eeprom;
  //------------------------------------------
  Serial.println("---------------");
  Serial.println(toString_eeprom);
  Serial.println("---------------");
  //------------------------------------------
  if (long_t == len_eeprom)
  {
    if (toString_eeprom.equals(t))
    {
      flag = true;
      EEPROM.write(9, 1);
    }
    else
    {
      flag = false;
      EEPROM.write(9, 0);
    }
  }
  return flag;
}

void xml_access(EthernetClient cl)
{
  cl.print("<?xml version = \"1.0\" ?>");
  cl.print("<inputs>");
  cl.print("<pass1>");
  cl.print("sesamo");
  cl.print("</pass1>");
  cl.println("</inputs>");
}

//--------------------------------------------------------------------------------------------------------------

boolean acceso_admin(String t2, int long_t2)
{
  bool flag2 = false;
  for (int x = 0; x <= len_eeprom2; x++)
  {
    array_eeprom2[x] = EEPROM.read(x + 10);
  }
  toString_eeprom2 = (String)array_eeprom2;
  //------------------------------------------
  Serial.println("---------------");
  Serial.println(toString_eeprom2);
  Serial.println("---------------");
  //------------------------------------------
  if (long_t2 == len_eeprom2)
  {
    if (toString_eeprom2.equals(t2))
    {
      flag2 = true;
      EEPROM.write(17, 1);
    }
    else
    {
      flag2 = false;
      EEPROM.write(17, 0);
    }
  }
  return flag2;
}

void xml_admin(EthernetClient cl)
{
  cl.print("<?xml version = \"1.0\" ?>");
  cl.print("<inputs>");
  cl.print("<pass1>");
  cl.print("ittg");
  cl.print("</pass1>");
  cl.println("</inputs>");
}

